/*
    This script class implements writing to and loading from a config file.
    It can be used if scripts need to store data persistently. 
*/


class ConfigFile
{
    // The configuration data members ----------------------------------------
    // Replace these by your own data items    
    string mTestString1;
    double mTestDouble1;
    string mTestString2;
    int mTestInt1;
    // -----------------------------------------------------------------------
    
    
    
    // -----------------------------------------------------------------------
    // You will need to adapt the following three functions according to your needs.
    
    // Set all config data members to appropriate default values
    void LoadDefaults()
    {
        mTestString1 = "Default Test String 1";
        mTestDouble1 = 0;
        mTestString2 = "Default Test String 2";;
        mTestInt1 = 0;
    }
    
    // Read the configuration data from the file
    bool ReadContent()
    {
        bool success = mFile.SeekToBegin();
        
        // Replace these calls according to your needs. Ensure that the order of
        // calls is the same as in function 'WriteContent'!
        success = success && mFile.Read(mTestString1);
        success = success && mFile.Read(mTestDouble1);
        success = success && mFile.Read(mTestString2);
        success = success && mFile.Read(mTestInt1);
        
        return success;    
    }
    
    // Write the configuration data to the file
    bool WriteContent()
    {
        bool success = mFile.SeekToBegin();
        
        // Replace these calls according to your needs. Ensure that the order of
        // calls is the same as in function ReadContent'!
        success = success && WriteString(mTestString1);
        success = success && mFile.Write(mTestDouble1);
        success = success && WriteString(mTestString2);
        success = success && mFile.Write(mTestInt1);
        
        mFile.Flush();
        
        return success;
    }
    
    // ------------------------------------------------------------------------
    
    
    
    // -------------------- Do not edit below this line -----------------------
    ConfigFile(string path)
    {
        mPath = path;
        mFile.Close();
    }
    
    // Open the config file. Create the file it it does not already exist
    bool Open()
    {
        return mFile.Open(mPath, FILE_MODE_READ_WRITE | FILE_MODE_CREATE | 
                          FILE_MODE_NO_TRUNCATE | FILE_SHARE_DENY_NONE | FILE_TYPE_BINARY);
    }
    
    void Close()
    {
        mFile.Close();
    }
    
       
    
    // Write a string to the file. Appends the required line feed character.
    bool WriteString(string &in s)
    {
        return mFile.Write(s + "\n");
    }
    
    // members
    string mPath;
    file mFile;
};